﻿Type=StaticCode
Version=3.8
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
Dim TabAccounts As List


Type TypeMemories( _ 
  HeapAlloc As Long, _
  HeapFree As Long, _
  HeapSize As Long)
Dim TabMemories(10) As TypeMemories
Dim IndMemories As Int

End Sub

Sub FormatMemory (Memory As Long) As Long
 
	Memory = Memory / 1024
	'Memory = Memory / 1024
	
	Return Memory

End Sub

Sub CheckMemory
Dim RelectorMemory As Reflector 
Dim args(0) As Object
Dim types(0) As String
Dim Diff As Long


	TabMemories(IndMemories).HeapAlloc = RelectorMemory.RunStaticMethod("android.os.Debug", "getNativeHeapAllocatedSize", args, types)
	TabMemories(IndMemories).HeapFree  = RelectorMemory.RunStaticMethod("android.os.Debug","getNativeHeapFreeSize", args, types)
	TabMemories(IndMemories).HeapSize  = RelectorMemory.RunStaticMethod("android.os.Debug","getNativeHeapSize", args, types)
	'Msgbox(ah, "ALLOCATED HEAP")
	'Msgbox(fh, "FREE HEAP")
	'Msgbox(gnhs, "getNativeHeapSize")
	
	IndMemories = IndMemories + 1 
	
	If IndMemories > 9 Then
	
		Log("HeapAlloc")
	  	For IndMemories = 0 To 9
	    	Log(FormatMemory(TabMemories(IndMemories).HeapAlloc))
	  	Next
		
		Log("HeapFree")
	  	For IndMemories = 0 To 9
	    	Log(FormatMemory(TabMemories(IndMemories).HeapFree))
	  	Next
		
		Log("HeapSize")
	  	For IndMemories = 0 To 9
	    	Log(FormatMemory(TabMemories(IndMemories).HeapSize))
	  	Next
		
		Log("DIFFERENCE")
		Diff = TabMemories(9).HeapAlloc - TabMemories(0).HeapAlloc
		Log("HeapAlloc=" & FormatMemory(Diff))
		
		Diff = TabMemories(9).HeapFree - TabMemories(0).HeapFree
		Log("HeapFree=" & FormatMemory(Diff))
		
		Diff = TabMemories(9).HeapSize - TabMemories(0).HeapSize
		Log("HeapSize=" & FormatMemory(Diff))
		
		IndMemories = 0
		
	End If
	
End Sub

Sub TrimWidth(CanvasText As Canvas, Text As String, Style As Typeface, Size As Int, MaxWidth As Int) As String
Dim Width As Int
	
	
	If Style.IsInitialized = False Then
	  	Style = Typeface.DEFAULT
	End If
	
	Width = CanvasText.MeasureStringWidth(Text, Style, Size)
	If Width >= MaxWidth Then
		Do Until Width < MaxWidth
			Text = Text.SubString2(0, Text.Length - 1)
			Width = CanvasText.MeasureStringWidth(Text, Style, Size)
		Loop
		Text = Text.SubString2(0, Text.Length - 3) & "..."
		Return Text
	Else
		Return Text
	End If
	
End Sub