﻿Type=Activity
Version=3.8
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: False
#End Region

'Activity module
Sub Process_Globals
'These global variables will be declared once when the application starts.
'These variables can be accessed from all modules.

End Sub

Sub Globals
'These global variables will be redeclared each time the activity is created.
'These variables can only be accessed from this module.
Dim EventsList As ScrollView
Dim Fn As Functions

Dim BitmapEnci As Bitmap
Dim BitmapCsen As Bitmap

Type TypeEvents( _ 
  ID As Int, _
  Pagine As Int, _
  Locandina As ImageView)
Dim TabEvents(50) As TypeEvents
Dim IndEvents As Int

End Sub

Sub Activity_Create(FirstTime As Boolean)
Dim Rc As Boolean
Dim ThisPhone As Phone


	If FirstTime == True Then
		
	End If
	
	ThisPhone.SetScreenOrientation(-1)

	
	EventsList.Initialize(500)
	Activity.AddView(EventsList, 0, 0, 100%x, Activity.Height - 50dip)
	Rc = SetEventsList
	If Rc == False Then
		Activity.Finish
	End If
	
	Fn.Initialize(Activity, Me)
	Fn.SetIconActionBar(Fn.ID_ACTION_HOME, "")
	Fn.CreateActionBar
	
	Fn.CreateAdMob(Main.gAdId)
	
End Sub

Sub SetEventsList As Boolean

Dim JsonString As String
Dim Json As JSONParser
Dim GlobalMap As Map
Dim ResultMap As Map
Dim ValuesItems As List
Dim ValueMap As Map

Dim Panel0 As Panel
Dim PanelTop, PanelHeight As Int
Dim Panel1 As Panel
Dim Label1, Label2, Label3, Label4 As Label
Dim LabelWidth As Int
Dim CanvasText As Canvas
Private BitmapText As Bitmap




	BitmapEnci.Initialize(File.DirAssets,"enci.png")
	BitmapCsen.Initialize(File.DirAssets,"csen.png")
	'BitmapEnci.InitializeSample(File.DirAssets,"enci.png", 65dip, 180dip)
    'BitmapCsen.InitializeSample(File.DirAssets,"csen.png", 65dip, 180dip)

	PanelTop=42dip
	Panel0=EventsList.Panel
	Panel0.Color=Colors.Gray
	
	If File.Exists(File.DirAssets, "Calendar.json") = False Then 
	  Msgbox ("Calendario non ricevuto", "Errore")
	  Return False
	End If
	
	Log ("Size Calendar.json=" & File.Size(File.DirInternal, "Calendar.json")) 

	
	JsonString = File.GetText (File.DirAssets, "Calendar.json") 
	
	Log (JsonString)
	
	Json.Initialize(JsonString)
	
	GlobalMap = Json.NextObject
	ResultMap = GlobalMap.Get("Result")
		
	Log("code=" & ResultMap.Get("code"))
	Log("details=" & ResultMap.Get("details"))
		
	If ResultMap.Get("code") <> 0 Then
		Msgbox("Errore ricezione calendario", "Calendario")
		ExitApplication
	End If
	
	ValuesItems = GlobalMap.Get("Calendar")
	

	LabelWidth = Activity.Width - 80dip
	'Msgbox ("LabelWidth=" & LabelWidth, "Debug")
	
	
	'CanvasText.Initialize(Activity)
	BitmapText.InitializeMutable(2dip, 2dip)   
	CanvasText.Initialize2(BitmapText)
	
	For i = 0 To ValuesItems.Size - 1
		ValueMap = ValuesItems.Get(i)
		
		Log("--------------------")
		Log("id=" & ValueMap.Get("id"))
		Log("giornate=" & ValueMap.Get("giornate"))
		Log("mancano=" & ValueMap.Get("mancano"))
		Log("struttura=" & ValueMap.Get("struttura"))
		Log("nome=" & ValueMap.Get("nome"))
		Log("citta=" & ValueMap.Get("citta"))
		Log("provincia=" & ValueMap.Get("provincia"))
		Log("distanza=" & ValueMap.Get("distanza"))
		Log("percentuale=" & ValueMap.Get("percentuale"))
		Log("locandine=" & ValueMap.Get("locandine"))
		
		
		TabEvents(i).Initialize
		TabEvents(i).ID = ValueMap.Get("id")
		TabEvents(i).Pagine = ValueMap.Get("locandine")
		
		
		
		
	 	Panel1.Initialize("View")
		Panel1.Tag = i
		
		PanelHeight=99dip
		
		Panel0.AddView(Panel1,0,PanelTop,EventsList.Width,PanelHeight)
		Panel1.Color=Colors.Black
		
		TabEvents(i).Locandina.Initialize("View")
		TabEvents(i).Locandina.Tag = i
		Panel1.AddView(TabEvents(i).Locandina,5dip,5dip,65dip,90dip)
		
		If ValueMap.Get("tipo") == "ENCI" Then
			TabEvents(i).Locandina.Bitmap=BitmapEnci
		End If
		If ValueMap.Get("tipo") == "CSEN" Then
			TabEvents(i).Locandina.Bitmap=BitmapCsen
		End If
		TabEvents(i).Locandina.Gravity = Gravity.FILL
		
		
		
		Label1.Initialize("View")
		Panel1.AddView(Label1,80dip,5dip,LabelWidth,30dip)
		Label1.Color=Colors.Black
		Label1.Tag = i
		Label1.Text=ValueMap.Get("giornate")
		If  ValueMap.Get("mancano") == "0" Then
			Label1.Text = Label1.Text & " oggi"
		Else
			Label1.Text = Label1.Text & " -" & ValueMap.Get("mancano") & " giorni"
		End If
		Label1.TextSize=17
		Label1.Text = Common.TrimWidth(CanvasText, Label1.Text, Label1.Typeface, Label1.TextSize, LabelWidth)
		
		
		Label2.Initialize("View")
		Panel1.AddView(Label2,80dip,28dip,LabelWidth,30dip)
		Label2.Tag = i
		Label2.Text= "Gara " & ValueMap.Get("tipo") & " " & ValueMap.Get("nome")
		Label2.TextSize=17
		Label2.Text = Common.TrimWidth(CanvasText, Label2.Text, Label2.Typeface, Label2.TextSize, LabelWidth)
		
		
		Label3.Initialize("View")
		Panel1.AddView(Label3,80dip,52dip,LabelWidth,30dip)
		Label3.Tag = i
		Label3.Text=ValueMap.Get("struttura")
		Label3.TextSize=17
		Label3.Text = Common.TrimWidth(CanvasText, Label3.Text, Label3.Typeface, Label3.TextSize, LabelWidth)
		

		Label4.Initialize("View")
		Panel1.AddView(Label4,80dip,75dip,LabelWidth,30dip)
		Label4.Tag = i
		Label4.Text=ValueMap.Get("citta") & " (" & ValueMap.Get("provincia") & ") " & ValueMap.Get("distanza")
		Label4.TextSize=17
		Label4.Text = Common.TrimWidth(CanvasText, Label4.Text, Label4.Typeface, Label4.TextSize, LabelWidth)
		
		
		PanelTop=PanelTop+PanelHeight+1dip
		
	Next
	
	Panel0.Height=PanelTop
	
	'BitmapEnci = Null
	'BitmapCsen = Null
	
	IndEvents = FindLocandina(-1)
   
    Common.CheckMemory
	
	Return True
	
End Sub

Sub FindLocandina(IndEvent As Int) As Int
Dim IDEvent As Int


    IndEvent = IndEvent + 1

	Log("--------------------")
	For Ind=IndEvent To TabEvents.Length - 1
		' Download otther images
	Next
	
	Log ("End FindLocandina")
	
	Return -1
	
End Sub

Sub Activity_Resume
	
	Fn.Resume
  
End Sub

Sub Activity_Pause (UserClosed As Boolean)

	Fn.Pause
	
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean

	If KeyCode = KeyCodes.KEYCODE_BACK Then
		ActionBar_Home
	End If
	
	Return False
	
End Sub 
Sub ActionBar_Home

  	Activity.Finish
	
End Sub
